--[[ NOTES

	Version 2
	10/26/2012
		- split elegon addon off from rapture addon.  appropriately renamed "MooseElegonSim"
		- "/mooser elegon" command now just "/elegon"
		- added "/elegon help" spam
		- control key no longer needs to be held to drag the bar
		- right-clicking the timer bar to stop the sim now prints the end-sim dataz
		
	10/26/2012
		- accidentally deleted the line that updated the health status bar at some point, but it's back now.
]]

--**************************************************
-- addon globals
local strlower, tostring, print, pcall, floor = strlower, tostring, print, pcall, floor
local BarTextures = {
["Solid"] = "solid",
["Gradient"] = "gradient",
["Blizzard"] = "Interface\\TargetingFrame\\UI-StatusBar",
["BantoBar"] = "Interface\\Addons\\mooserapture\\textures\\BantoBar",
["Frost"] = "Interface\\Addons\\mooserapture\\textures\\Frost",
["Healbot"] = "Interface\\Addons\\mooserapture\\textures\\Healbot",
["LiteStep"] = "Interface\\Addons\\mooserapture\\textures\\LiteStep",
["Minimalist"] = "Interface\\Addons\\mooserapture\\textures\\Minimalist",
["Rocks"] = "Interface\\Addons\\mooserapture\\textures\\Rocks",
["Runes"] = "Interface\\Addons\\mooserapture\\textures\\Runes",
["Xeon"] = "Interface\\Addons\\mooserapture\\textures\\Xeon",
}
local MOOSE_ELEGON_BAR_SETTINGS = {
	["enabled"] = true,
	["locked"] = false,
	--["isUserPlacedYet"] = false,
	["x"] = 180,								--length
	["y"] = 18,								--width
	["texture"] = BarTextures["Gradient"],		--bartexture
	["r"] = 0,								--bar color value RED		maybe should just make these hex values
	["g"] = .5,								--bar color value GREEN
	["b"] = .75,								--bar color value BLUE
	["a"] = .75,								--bar color value ALPHA
	["bgr"] = 0,								--bar BACKGROUND color value RED
	["bgg"] = 0,								--bar BACKGROUND color value GREEN	
	["bgb"] = 0,								--bar BACKGROUND color value BLUE
	["bga"] = .25,								--bar BACKGROUND color value ALPHA
	["isGrad"] = true,						
	["gradStartR"] = 0,						--bottom gradiant colors, gradient colors override r,g,b,a colors
	["gradStartG"] = 0,
	["gradStartB"] = 1,
	["gradStartA"] = .6,
	["gradEndR"] = 0,						--top
	["gradEndG"] = 0,
	["gradEndB"] = 0,
	["gradEndA"] = .6,
	["gradOrient"] = "VERTICAL",
}	
local ONUPDATE_SPEED = .033		--constant (~30 fps).		the maximum rate which the onupdate handler can update the statusbar
local addonTag = "\124cffffcc00[Elegon Sim]:\124r"
local playerName = UnitName("player")
local elegon_times = {
	[1] = {["text"] = "Draw Power (drag me)",["TIME"] = 15,},
	[2] = {["text"] = "Wave One",["TIME"] = 16,},
	[3] = {["text"] = "Draw Power",["TIME"] = 3,},
	[4] = {["text"] = "Wave Two",["TIME"] = 13.33,},
	[5] = {["text"] = "Draw Power",["TIME"] = 3,},
	[6] = {["text"] = "Wave Three",["TIME"] = 11.43,},
	[7] = {["text"] = "Draw Power",["TIME"] = 3,},
	[8] = {["text"] = "Wave Four",["TIME"] = 10,},
	[9] = {["text"] = "Draw Power",["TIME"] = 3,},
	[10] = {["text"] = "Wave Five",["TIME"] = 8.9,},
	[11] = {["text"] = "Draw Power",["TIME"] = 3,},
	[12] = {["text"] = "Wave Six",["TIME"] = 8,},
	[13] = {["text"] = "TRANSITION PHASE",["TIME"] = 5,},
}
local elegon = 0
local elegondmg = {}
local MR_Events = {
	["ADDON_LOADED"] = function(self)
		self:UnregisterEvent("ADDON_LOADED")
		
		SLASH_ELEGON1 = '/elegon'

		self:SetUpBar()
	end,
}
local MR_SlashCmds = {
	[0] = function()			--vanilla command
		print(addonTag,"Starting Elegon Energy Charge simulation...")
		print(addonTag,"Stop anytime by right-clicking the timer.")
		elegon = 0
		elegondmg = {}
		MooseElegonTimerBar:StartCooldown_Elegon()
	end,
	[1] = function(msg)		--error
		--print(addonTag,"command \""..msg.."\" not recognized. Type \"\124cffaaaaaa/mooser commands\124r\" if you need a list of valid commands.")
	end,
	["help"] = function()
		print(addonTag,"This addon helps you simulate the Energy Charge phase in the Elegon encounter using timers and simulated health bar.")
		print("To begin, \124cffffcc00type \124cffaaaaaa/elegon\124r. A timer for the intial Draw Power will appear, allowing you to get situated. \124cffffcc00FOCUS TARGET\124r a training dummy, and start dpsing a different dummy until the draw power ends. \124cffff0000*DO NOT dps, or even target, your focus until the energy charge wave begins*\124r That would be cheating!")
		print("As soon as the energy charge wave starts, switch to your focus target and dps it. The simulated health bar under the timer bar will show you how much damage you need to put out.")
		print("Switch your focus target to a clean dummy (one without DoTs and stuff) between waves to prevent false DoT damage being tracked.")
		print("Kill as many waves as you can without cheating. The sim will stop after 6 waves have completed, regardless of you failing to kill a wave.")
		print("Your damage will be printed out at the end of the sim, showing you which waves you passed or failed.")
	end,
}

--********************************************************

MooseElegonTimerBar:RegisterEvent("ADDON_LOADED")
MooseElegonTimerBar:SetScript("OnEvent",function(self,event,...)
	if MR_Events[event] ~= nil then pcall(MR_Events[event],self,event,...) end
end)

function SlashCmdList.ELEGON(msg)
	msg = strlower(msg)
	if msg == "" then msg = 0 end
	if MR_SlashCmds[msg] ~= nil then
		pcall(MR_SlashCmds[msg])
	else
		pcall(MR_SlashCmds[1],msg)
	end
end

local elegondmgtracker = CreateFrame("frame")
elegondmgtracker:SetScript("OnEvent",function(self,event,...)
	local timestamp,vent,hideCaster,sourceGUID,sourceName,sourceFlags,sourceRaidFlags,destGUID,destName,destFlags,destRaidFlags = select(1, ...)
	if (sourceGUID ~= UnitGUID("player") and sourceGUID ~= UnitGUID("pet")) or destGUID ~= UnitGUID("focus") then return end
	if vent == "SPELL_DAMAGE" or vent == "SPELL_PERIODIC_DAMAGE" or vent == "RANGE_DAMAGE" then
	--if strfind(vent,"SPELL") or strfind(vent,"RANGE") then
		local arg12,arg13,arg14,amt,over,arg17 = select(12, ...)
		elegondmgtracker.dmg = elegondmgtracker.dmg + amt
		--MooseElegonHealthBar.TimerText:SetText(492400 - (elegondmgtracker.dmg * 1.5))
		MooseElegonHealthBar.TimerText:SetText(tostring(floor((492400 - (elegondmgtracker.dmg * 1.5))/1000)).."k")
		MooseElegonHealthBar:SetValue(((492400 - (elegondmgtracker.dmg * 1.5)) / 492400) * 100)
		if elegondmgtracker.dmg * 1.5 >= 492400 then
			print(addonTag,"Energy Charge dead!")
			elegondmgtracker:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			MooseElegonHealthBar:Hide()
		end
	elseif vent == "SWING_DAMAGE" then
		local arg12,arg13,arg14,amt,over,arg17 = select(12, ...)
		elegondmgtracker.dmg = elegondmgtracker.dmg + arg12
		MooseElegonHealthBar.TimerText:SetText(tostring(floor((492400 - (elegondmgtracker.dmg * 1.5))/1000)).."k")
		MooseElegonHealthBar:SetValue(((492400 - (elegondmgtracker.dmg * 1.5)) / 492400) * 100)
		if elegondmgtracker.dmg * 1.5 >= 492400 then
			print(addonTag,"Energy Charge dead!")
			elegondmgtracker:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			MooseElegonHealthBar:Hide()
		end
	end
end)

function MooseElegonTimerBar:StartCooldown_Elegon()
	--reset and start onupdate stuff
	elegon = elegon + 1
	MooseElegonTimerBar.TimeSinceLastUpdate = 0
	MooseElegonTimerBar.CooldownTimer = elegon_times[elegon].TIME
	MooseElegonTimerBar.CooldownBaseTime = elegon_times[elegon].TIME
	MooseElegonTimerBar:SetScript("OnUpdate",nil)
	MooseElegonTimerBar:Show()
	MooseElegonTimerBar.TimerText:SetText(MooseElegonTimerBar.CooldownTimer)
	MooseElegonTimerBar.Text:SetText(elegon_times[elegon].text)
	MooseElegonTimerBar:SetValue( select(2,MooseElegonTimerBar:GetMinMaxValues()) )	--set value to max
	MooseElegonTimerBar:SetScript("OnUpdate",MooseCooldownBar_Elegon_OnUpdate)
	
	if floor(elegon/2) == elegon/2 then
		elegondmgtracker:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		elegondmgtracker.dmg = 0
		MooseElegonHealthBar:Show()
		MooseElegonHealthBar.Text:SetText("Energy Sparkydoo")
		MooseElegonHealthBar.TimerText:SetText("492k")
		MooseElegonHealthBar:SetValue( select(2,MooseElegonHealthBar:GetMinMaxValues()) )	--set value to max
	else
		elegondmgtracker:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		elegondmg[(elegon - 1)/2] = elegondmgtracker.dmg
		MooseElegonHealthBar:Hide()
	end
end

function MooseElegonTimerBar:ElegonFinish()
	elegondmgtracker:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	print(addonTag,"Simulation stopped.")
	if #elegondmg == 0 then return end
	print(addonTag,"\124cff00ccccActual damage done   (damage done * 1.5)\124r")
	for x=1,#elegondmg do
		if elegondmg[x]*(1.5) >= 492400 then
			print(addonTag,"Wave",x,":    \124cff00ff00",elegondmg[x]," ("..elegondmg[x]*(1.5)..")\124r")
		else
			print(addonTag,"Wave",x,":    \124cffff0000",elegondmg[x]," ("..elegondmg[x]*(1.5)..")\124r")
		end
	end
end

function MooseCooldownBar_Elegon_OnUpdate(self,elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed
	
	--when the cooldown is finished...
	if self.CooldownTimer <= 0 then
		if not elegon_times[elegon + 1] then
			self:ElegonFinish()
			self.CooldownTimer = 0
			self:Hide()
			return
		end
		
		self.CooldownTimer = 0
		self:StartCooldown_Elegon()
		return
	end
	
	if self.TimeSinceLastUpdate >= ONUPDATE_SPEED then
		self.CooldownTimer = self.CooldownTimer - ONUPDATE_SPEED
		self:SetValue( select(2,self:GetMinMaxValues()) * (self.CooldownTimer / self.CooldownBaseTime) )
		self.TimerText:SetFormattedText("%.1f",self.CooldownTimer)
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - ONUPDATE_SPEED
	end
end

function MooseElegonTimerBar:SetUpBar()
	
	local HealthBar = MooseElegonHealthBar
	
	--Timer Bar stuff
	self:SetWidth(MOOSE_ELEGON_BAR_SETTINGS["x"])
	self:SetHeight(MOOSE_ELEGON_BAR_SETTINGS["y"])
	self:SetMinMaxValues(0,100)
	self:SetValue(0)
	if not self.TimeSinceLastUpdate then	self.TimeSinceLastUpdate = 0 end
	if not self.isMoving then self.isMoving = false end
	if not self.CooldownTimer then self.CooldownTimer = 0 end
	
	--create statusbar BACKGROUND texture
	self.BGtexture = MooseElegonTimerBar_BGTexture
	self.BGtexture:SetTexture(MOOSE_ELEGON_BAR_SETTINGS["bgr"],MOOSE_ELEGON_BAR_SETTINGS["bgg"],MOOSE_ELEGON_BAR_SETTINGS["bgb"],MOOSE_ELEGON_BAR_SETTINGS["bga"])
	self.BGtexture:SetAllPoints()
	
	--create texture object for the statusbar
	if not self.StatusBarTexture then self.StatusBarTexture = self:CreateTexture(self:GetName().."_StatusBarTexture","BACKGROUND") end
	if MOOSE_ELEGON_BAR_SETTINGS["texture"] == "solid" then	--set texture as a solid color
		self.StatusBarTexture:SetTexture(MOOSE_ELEGON_BAR_SETTINGS["r"],MOOSE_ELEGON_BAR_SETTINGS["g"],MOOSE_ELEGON_BAR_SETTINGS["b"],MOOSE_ELEGON_BAR_SETTINGS["a"])
		self:SetStatusBarTexture(self.StatusBarTexture)
	elseif MOOSE_ELEGON_BAR_SETTINGS["texture"] == "gradient" then	--set texture as a gradient
		self.StatusBarTexture:SetTexture(1,1,1,1)	--solid white, because SetGradient() doesn't overwrite the texture color, only adds a filter.
		self.StatusBarTexture:SetGradientAlpha(
			MOOSE_ELEGON_BAR_SETTINGS["gradOrient"],
			MOOSE_ELEGON_BAR_SETTINGS["gradStartR"],
			MOOSE_ELEGON_BAR_SETTINGS["gradStartG"],
			MOOSE_ELEGON_BAR_SETTINGS["gradStartB"],
			MOOSE_ELEGON_BAR_SETTINGS["gradStartA"],
			MOOSE_ELEGON_BAR_SETTINGS["gradEndR"],
			MOOSE_ELEGON_BAR_SETTINGS["gradEndG"],
			MOOSE_ELEGON_BAR_SETTINGS["gradEndB"],
			MOOSE_ELEGON_BAR_SETTINGS["gradEndA"]	)
		self:SetStatusBarTexture(self.StatusBarTexture)
	else
		self.StatusBarTexture:SetTexture(MOOSE_ELEGON_BAR_SETTINGS["texture"])
		if MOOSE_ELEGON_BAR_SETTINGS["isGrad"] then
			self.StatusBarTexture:SetTexture(1,1,1,1)	--solid white, because SetGradient() doesn't overwrite the texture color, only adds a filter.
			self.StatusBarTexture:SetGradientAlpha(
				MOOSE_ELEGON_BAR_SETTINGS["gradOrient"],
				MOOSE_ELEGON_BAR_SETTINGS["gradStartR"],
				MOOSE_ELEGON_BAR_SETTINGS["gradStartG"],
				MOOSE_ELEGON_BAR_SETTINGS["gradStartB"],
				MOOSE_ELEGON_BAR_SETTINGS["gradStartA"],
				MOOSE_ELEGON_BAR_SETTINGS["gradEndR"],
				MOOSE_ELEGON_BAR_SETTINGS["gradEndG"],
				MOOSE_ELEGON_BAR_SETTINGS["gradEndB"],
				MOOSE_ELEGON_BAR_SETTINGS["gradEndA"]	)
			self:SetStatusBarTexture(self.StatusBarTexture)
		else
			self:SetStatusBarTexture(self.StatusBarTexture)
			self:SetStatusBarColor(MOOSE_ELEGON_BAR_SETTINGS["r"],MOOSE_ELEGON_BAR_SETTINGS["g"],MOOSE_ELEGON_BAR_SETTINGS["b"],MOOSE_ELEGON_BAR_SETTINGS["a"])
		end
	end
	
	--set statusbar border (which is actually a separate frame)
	self.Border = MooseElegonTimerBar_Border
	self.Border:Lower()
	self.Border:SetWidth(MooseElegonTimerBar:GetWidth() + 4)
	self.Border:SetHeight(MooseElegonTimerBar:GetHeight() + 4)
	
	--set up fontstring for cooldown spell label
	self.Text = MooseElegonTimerBar_Text
	self.Text:SetWidth(self:GetWidth()*.75)
	self.Text:SetHeight(self:GetHeight())
	
	--set up frontstring for timer text
	self.TimerText = MooseElegonTimerBar_TimerText
	self.TimerText:SetWidth(self:GetWidth()*.25)
	self.TimerText:SetHeight(self:GetHeight())
	
	
	
	-- health bar stuff
	HealthBar:SetWidth(MOOSE_ELEGON_BAR_SETTINGS["x"])
	HealthBar:SetHeight(MOOSE_ELEGON_BAR_SETTINGS["y"])
	HealthBar:SetMinMaxValues(0,100)
	HealthBar:SetValue(0)
	
	HealthBar.BGtexture = MooseElegonHealthBar_BGTexture
	HealthBar.BGtexture:SetTexture(MOOSE_ELEGON_BAR_SETTINGS["bgr"],MOOSE_ELEGON_BAR_SETTINGS["bgg"],MOOSE_ELEGON_BAR_SETTINGS["bgb"],MOOSE_ELEGON_BAR_SETTINGS["bga"])
	HealthBar.BGtexture:SetAllPoints()
	
	if not HealthBar.StatusBarTexture then HealthBar.StatusBarTexture = HealthBar:CreateTexture(HealthBar:GetName().."_StatusBarTexture","BACKGROUND") end
	if MOOSE_ELEGON_BAR_SETTINGS["texture"] == "solid" then	--set texture as a solid color
		HealthBar.StatusBarTexture:SetTexture(MOOSE_ELEGON_BAR_SETTINGS["r"],MOOSE_ELEGON_BAR_SETTINGS["g"],MOOSE_ELEGON_BAR_SETTINGS["b"],MOOSE_ELEGON_BAR_SETTINGS["a"])
		HealthBar:SetStatusBarTexture(HealthBar.StatusBarTexture)
	elseif MOOSE_ELEGON_BAR_SETTINGS["texture"] == "gradient" then	--set texture as a gradient
		HealthBar.StatusBarTexture:SetTexture(1,1,1,1)	--solid white, because SetGradient() doesn't overwrite the texture color, only adds a filter.
		HealthBar.StatusBarTexture:SetGradientAlpha(
			MOOSE_ELEGON_BAR_SETTINGS["gradOrient"],
			MOOSE_ELEGON_BAR_SETTINGS["gradStartR"],
			MOOSE_ELEGON_BAR_SETTINGS["gradStartG"],
			MOOSE_ELEGON_BAR_SETTINGS["gradStartB"],
			MOOSE_ELEGON_BAR_SETTINGS["gradStartA"],
			MOOSE_ELEGON_BAR_SETTINGS["gradEndR"],
			MOOSE_ELEGON_BAR_SETTINGS["gradEndG"],
			MOOSE_ELEGON_BAR_SETTINGS["gradEndB"],
			MOOSE_ELEGON_BAR_SETTINGS["gradEndA"]	)
		HealthBar:SetStatusBarTexture(HealthBar.StatusBarTexture)
	else
		HealthBar.StatusBarTexture:SetTexture(MOOSE_ELEGON_BAR_SETTINGS["texture"])
		if MOOSE_ELEGON_BAR_SETTINGS["isGrad"] then
			HealthBar.StatusBarTexture:SetTexture(1,1,1,1)	--solid white, because SetGradient() doesn't overwrite the texture color, only adds a filter.
			HealthBar.StatusBarTexture:SetGradientAlpha(
				MOOSE_ELEGON_BAR_SETTINGS["gradOrient"],
				MOOSE_ELEGON_BAR_SETTINGS["gradStartR"],
				MOOSE_ELEGON_BAR_SETTINGS["gradStartG"],
				MOOSE_ELEGON_BAR_SETTINGS["gradStartB"],
				MOOSE_ELEGON_BAR_SETTINGS["gradStartA"],
				MOOSE_ELEGON_BAR_SETTINGS["gradEndR"],
				MOOSE_ELEGON_BAR_SETTINGS["gradEndG"],
				MOOSE_ELEGON_BAR_SETTINGS["gradEndB"],
				MOOSE_ELEGON_BAR_SETTINGS["gradEndA"]	)
			HealthBar:SetStatusBarTexture(HealthBar.StatusBarTexture)
		else
			HealthBar:SetStatusBarTexture(HealthBar.StatusBarTexture)
			HealthBar:SetStatusBarColor(MOOSE_ELEGON_BAR_SETTINGS["r"],MOOSE_ELEGON_BAR_SETTINGS["g"],MOOSE_ELEGON_BAR_SETTINGS["b"],MOOSE_ELEGON_BAR_SETTINGS["a"])
		end
	end
	
	HealthBar.Border = MooseElegonHealthBar_Border
	HealthBar.Border:Lower()
	HealthBar.Border:SetWidth(HealthBar:GetWidth() + 4)
	HealthBar.Border:SetHeight(HealthBar:GetHeight() + 4)
	
	HealthBar.Text = MooseElegonHealthBar_Text
	HealthBar.Text:SetWidth(HealthBar:GetWidth()*.75)
	HealthBar.Text:SetHeight(HealthBar:GetHeight())
	
	HealthBar.TimerText = MooseElegonHealthBar_TimerText
	HealthBar.TimerText:SetWidth(HealthBar:GetWidth()*.25)
	HealthBar.TimerText:SetHeight(HealthBar:GetHeight())
	
end








